import unittest
import aidge_core
import aidge_backend_cpu
import numpy as np


class test_scheduler(unittest.TestCase):
    """Test tensor binding
    """
    def setUp(self):
        pass
    def tearDown(self):
        pass

    def test_relu_forward(self):
        values = np.arange(6) - 3

        input_node = aidge_core.Producer(aidge_core.Tensor(values), "Input")
        relu = aidge_core.ReLU()

        gv = aidge_core.GraphView()
        gv.add(relu)
        gv.add(input_node)

        gv.set_datatype(aidge_core.DataType.Int32)
        gv.set_backend("cpu")

        input_node.add_child(relu)

        scheduler = aidge_core.SequentialScheduler(gv)

        scheduler.forward()

        out_tensor = relu.get_operator().output(0)
        expected_out = [0,0,0,0,1,2]
        for i in range(len(expected_out)):
            self.assertEqual(expected_out[i], out_tensor[i])



if __name__ == '__main__':
    unittest.main()
